const n = {
  merge: (s, e, t) => {
    if (!s && !e)
      return {};
    if (!s)
      return e;
    if (!e)
      return s;
    if (t != null && t.preserve) {
      const o = n.overlaps(s, e), i = n.omit(e, o);
      return { ...s, ...i };
    }
    return { ...s, ...e };
  },
  omit(s, e) {
    const t = {};
    for (const r in s)
      e.includes(r) || (t[r] = s[r]);
    return t;
  },
  pick(s, e) {
    const t = {};
    for (const r of e)
      t[r] = s[r];
    return t;
  },
  overlaps(s, e) {
    const t = Object.keys(s), r = Object.keys(e);
    return t.filter((i) => r.includes(i));
  },
  seialize(s) {
    return JSON.stringify(s);
  },
  deserialize(s) {
    try {
      return JSON.parse(s);
    } catch {
      throw "Invalid JSON";
    }
  },
  validate: {
    notNull: (s, e, t) => {
      s == null && (t == null || t.push("Validation Error: " + e));
    },
    string: (s, e, t) => {
      typeof s != "string" && (t == null || t.push("Validation Error: " + e));
    },
    object: (s, e, t) => {
      typeof s != "object" && (t == null || t.push("Validation Error: " + e));
    },
    number: (s, e, t) => {
      typeof s != "number" && (t == null || t.push("Validation Error: " + e));
    },
    notEmpty: (s, e, t) => {
      (!s || s.length === 0) && (t == null || t.push("Validation Error: " + e));
    }
  },
  throwErr: (s) => {
    throw s[0];
  },
  getValue: (s, e, t) => s[e] === void 0 ? t || null : s[e],
  /**
   * If the args is an array, it returns the array, otherwise it returns an array with the args as the only element
   */
  asArray(s) {
    return Array.isArray(s) ? s : [s];
  }
};
class c {
  constructor(e) {
    this.meta = {}, this.config = e.config, this.name = e.name, this.description = e.description, this.meta = e.meta, this.resources = Object.keys(e.config), this.permissions = this._init(e.config, this.resources);
  }
  getDefaultPermission(e) {
    return {
      c: "create",
      r: "read",
      u: "update",
      d: "delete",
      l: "list"
    }[e];
  }
  _init(e, t) {
    const r = {};
    for (const o of t) {
      const i = e[o].base, a = e[o].custom, f = new Set(i), u = {};
      for (const h of ["c", "r", "u", "d", "l"])
        u[this.getDefaultPermission(h)] = f.has(h);
      r[o] = n.merge(
        u,
        a
      );
    }
    return r;
  }
  getPermissions() {
    return this.permissions;
  }
  getResources() {
    return this.resources;
  }
  add(e) {
    const { permissions: t, resource: r, mutate: o, noOverride: i } = e;
    return o ? (this.config = n.merge(
      this.config,
      {
        [r]: t
      },
      {
        preserve: i
      }
    ), this.permissions = this._init(this.config, this.resources), this) : new c({
      name: this.name,
      description: this.description,
      meta: this.meta,
      config: n.merge(
        this.config,
        {
          [r]: t
        },
        {
          preserve: i
        }
      )
    });
  }
  // eslint-disable-next-line @typescript-eslint/ban-types
  remove(e) {
    const { resource: t, mutate: r } = e;
    return r ? (delete this.config[t], delete this.permissions[t], this) : new c({
      name: this.name,
      description: this.description,
      meta: this.meta,
      config: n.omit(this.config, [t])
    });
  }
  // eslint-disable-next-line @typescript-eslint/ban-types
  update(e) {
    const { permissions: t, resource: r, mutate: o, noOverride: i } = e;
    return o ? (this.config = n.merge(
      this.config,
      {
        [r]: t
      },
      {
        preserve: i
      }
    ), this.permissions = this._init(this.config, this.resources), this) : new c({
      name: this.name,
      description: this.description,
      meta: this.meta,
      config: n.merge(
        this.config,
        {
          [r]: t
        },
        {
          preserve: i
        }
      )
    });
  }
  can(e, t) {
    const o = new Map(Object.entries(this.getPermissions())).get(e);
    return o ? o[t] : !1;
  }
  cannot(e, t) {
    return !this.can(e, t);
  }
  canAny(e, t) {
    return t.some((r) => this.can(e, r));
  }
  canAll(e, t) {
    return t.every((r) => this.can(e, r));
  }
  clone() {
    return new c({
      name: this.name,
      description: this.description,
      meta: this.meta,
      config: this.config
    });
  }
  toJSON(e) {
    const t = n.seialize({
      name: this.name,
      description: this.description,
      meta: this.meta,
      config: this.config
    });
    return e ? e(t) : t;
  }
  toObject(e) {
    const t = {
      name: this.name,
      description: this.description,
      meta: this.meta,
      config: this.config,
      permissions: this.permissions,
      resources: this.resources
    };
    return e ? e(t) : t;
  }
  /**
   *  Creates a role from a JSON string
   */
  static fromJSON(e) {
    const t = n.deserialize(e);
    return this.fromObject(t);
  }
  /**
   * Creates a role from object
   */
  static fromObject(e) {
    const t = this.validate(e);
    return t.length ? n.throwErr(t) : new c({
      config: e.config,
      description: e.description,
      meta: e.meta,
      name: e.name
    });
  }
  /**
   * This method can be used when you want to create a role from an unknown data source
   * @example
   *
   * ```ts
   * // create a role from an encrypted string using aes-256-cbc algorithm
   * import crypto from 'crypto';
   *
   * const key = 'somekey';
   * const iv = 'someiv';
   * const algorithm = 'aes-256-cbc';
   * const key_buffer = Buffer.from(key);
   * const iv_buffer = Buffer.from(iv);
   *
   * const encrypted_role_json_str = 'some encrypted data';
   *
   * const decrypt = (data: string) => {
   *    const decipher = crypto.createDecipheriv(algorithm, key_buffer, iv_buffer);
   *    let decrypted = decipher.update(data, 'hex', 'utf8');
   *    decrypted += decipher.final('utf8');
   *    return decrypted;
   * };
   * const role = Role.from(encrypted_role_json_str, (data) => {
   *    const decrypted = decrypt(data); // decrypt the data
   *    return Role.fromJSON(decrypted).toObject(); // convert the decrypted data to a role object and return it
   * });
   * ```
   */
  static from(e, t) {
    const r = t(e);
    return new c(r);
  }
  static validate(e, t) {
    const { name: r, config: o } = e, i = [];
    return n.validate.notEmpty(Object.keys(e), "Role must not be empty", i), n.validate.notNull(r, "Name of the role is required", i), n.validate.string(r, "Name of the role must be a string", i), n.validate.notNull(o, "Config of the role is required", i), n.validate.object(o, "Config of the role must be an object", i), t && t(i.length === 0, i), i;
  }
}
class l {
  constructor(e) {
    this.schema = e;
  }
  _verifyPermissionsLoose(e, t, r) {
    return e ? r.some((o) => t.some((i) => e.can(i, o))) : !1;
  }
  _verifyPermissionsStrict(e, t, r) {
    return e ? r.every((o) => t.every((i) => e.can(i, o))) : !1;
  }
  _getRole(e) {
    return this.schema.getRole(e);
  }
  _construct(e) {
    if (typeof e == "string")
      return c.fromJSON(e);
    if (typeof e == "object")
      return c.fromObject(e);
    throw "Invalid argument for `_construct` method";
  }
  authorize(e) {
    if ("role" in e) {
      const t = this._getRole(e.role);
      return e.strict ? this._verifyPermissionsStrict(
        t,
        n.asArray(e.resources),
        n.asArray(e.actions)
      ) : this._verifyPermissionsLoose(
        t,
        n.asArray(e.resources),
        n.asArray(e.actions)
      );
    }
    if ("construct" in e) {
      const t = this._construct(e.data);
      return e.strict ? this._verifyPermissionsStrict(
        t,
        n.asArray(e.resources),
        n.asArray(e.actions)
      ) : this._verifyPermissionsLoose(
        t,
        n.asArray(e.resources),
        n.asArray(e.actions)
      );
    }
    throw "Invalid argument for `authorize` method";
  }
}
class m extends Error {
  constructor(e) {
    super(e), this.code = e;
  }
  static throw_error(e) {
    throw new m(e);
  }
  static throw_unknown_error(e) {
    throw Error(e);
  }
}
class d {
  constructor(e) {
    this.options = e;
  }
  /**
   * Get roles
   */
  get roles() {
    return this.options.roles;
  }
  /**
   * Get role by key
   */
  getRole(e) {
    return this.roles[e];
  }
  /**
   * Get all resources in the schema
   */
  getResources() {
    const e = {};
    for (const t in this.roles) {
      const r = this.roles[t].permissions;
      for (const o in r)
        e[o] = o;
    }
    return e;
  }
  /**
   * Get all permissions in the schema
   */
  getPermissions(e) {
    return this.roles[e].permissions;
  }
  toJSON(e, t) {
    const r = this.roles[e].toJSON();
    return t ? t(r) : r;
  }
  toObject(e, t) {
    const r = this.roles[e].toObject();
    return t ? t(r) : r;
  }
  /**
   * Check if a role exists in the schema
   */
  // eslint-disable-next-line @typescript-eslint/ban-types
  exists(e) {
    return !!this.roles[e];
  }
}
export {
  m as AuthError,
  l as AuthManager,
  c as Role,
  d as Schema
};
